-- Demonstration program for Jarod a/k/a/ the Pretender
-- By Mic, 2000
--
-- (should) work in 8, 15, 16 & 24-bit modes
--

include jarod.e


constant BPP = 8
constant ACCURATE = 0

sequence image


function init()
  if OPSYS = WIN32 then
    BPP16IS15 = 1
  end if
  if SetColorDepth(BPP) then
    return 1
  end if

  --/* Allow Load(/Save)Bitmap() to dither images when converting
  --   from ??? to 256 colors. */
  AllowDithering(1)
  if ACCURATE then
     --/* Allow Load(/Save)Bitmap() to create an optimized palette before doing
     --   the color matching (good results but takes a lot of time) */
     AllowPaletteOptimization(1)
  else
     SetMatchPalette(Generate332Palette())
  end if

  image = LoadBitmap(PATH("images/chibimarukochan.bmp"))
  if image[ERRORCODE] then
    return 1
  end if

  if GraphicsMode({320,240}) then
    return 1
  end if
  --// SetPalette() will check if an 8-bit graphics mode has been set.
  SetPalette(image[PALETTE])

  return 0
end function


function display()
  UpdateInput()
  if GetKey() != -1 then
    return -1
  end if
  WaitRetrace()
  Blit({32,10},image,VIDEO,SOURCECOPY)
  return 0
end function


function clean_up()
  DestroyBitmap(image)
  if GraphicsMode(0) then
  end if
  return 0
end function



WindowType(STANDARD)
WindowTitle("Jarod|bitmap")
Main(routine_id("init"),routine_id("display"),routine_id("clean_up"))
 