-- Demonstration program for Jarod a/k/a/ the Pretender
-- By Mic, 2000
--
-- This program demonstrates the keyboard routines.
--
-- (should) work in 8, 15, 16 & 24-bit modes
--


include jarod.e

sequence img1,img2,img3,img4,bitmap
atom f


function init()
  if GraphicsMode({320,240}) then
    return 1
  end if

  img1 = LoadBitmap(PATH("images/up.bmp"))
  img2 = LoadBitmap(PATH("images/down.bmp"))
  img3 = LoadBitmap(PATH("images/left.bmp"))
  img4 = LoadBitmap(PATH("images/right.bmp"))

  f = LoadFont(PATH("fonts/font.f"))
  SetPalette(img1[PALETTE])
  bitmap = CreateBitmap(320,240,1)

  return 0
end function



function mainloop()
integer key
  --// Update keyboard data.
  UpdateInput()
  key = GetKey()
  if key = KEY_SPACE then
    --// Exit if [Space] was pressed.
    return 1
  end if

  --// Clear 'bitmap' using color 0.
  ClearBitmapIndex(bitmap,0)
  TextOut({2,2},"Press arrow keys, or [Esc] to quit.",f,150,bitmap)

  if KeyDown(KEY_UP) then
    Blit({144,72},img1,bitmap,NOTNULLCOPY+NOCLIPCOPY)
  end if
  if KeyDown(KEY_DOWN) then
    Blit({144,136},img2,bitmap,NOTNULLCOPY+NOCLIPCOPY)
  end if
  if KeyDown(KEY_LEFT) then
    Blit({112,104},img3,bitmap,NOTNULLCOPY+NOCLIPCOPY)
  end if
  if KeyDown(KEY_RIGHT) then
    Blit({176,104},img4,bitmap,NOTNULLCOPY+NOCLIPCOPY)
  end if
  if KeyDown(KEY_ESCAPE) then
    return 1
  end if

  WaitRetrace()
  Blit({0,0},bitmap,VIDEO,SOURCECOPY)

  return 0
end function



function quit()
  if GraphicsMode(0) then end if
  DestroyBitmap({img1,img2,img3,img4,bitmap})
  DestroyFont(f)
  return 0
end function


WindowType(STANDARD)
Main(routine_id("init"),routine_id("mainloop"),routine_id("quit"))
