include vesa20.e
include ports.e
include beeampee2.e
include keyread.e
--include getid3tag.e



global constant CD = 0
constant MODE_Q=256
constant MODE_NES=240
 
--// Here are some data for tweaking VGA cards to get 256x???x256 modes.
--// First off is "Mode Q" (the [Q]ubic mode), 256x256x256.
--// The format is {Register, Function, Data} 
constant modeQ_tweakData={
{#3D4, #00, #5F},{#3D4, #01, #3F},{#3D4, #02, #40},{#3D4, #03, #82},
{#3D4, #04, #4A},{#3D4, #05, #9A},{#3D4, #06, #23},{#3D4, #07, #B2},
{#3D4, #08, #00},{#3D4, #09, #61},{#3D4, #10, #0A},{#3D4, #11, #AC},	
{#3D4, #12, #FF},{#3D4, #13, #20},{#3D4, #14, #40},{#3D4, #15, #07},
{#3D4, #16, #1A},{#3D4, #17, #A3},{#3C4, #01, #01},{#3C4, #04, #0E},
{#3CE, #05, #40},{#3CE, #06, #05},{#3C0, #30, #41}	
}

--// I didn't know if this mode had a name already so I decided to call
--// it "Mode NES" since this is the resolution (256x240) used by the
--// NTSC version of the Nintendo Entertainment system (tm).
constant modeNES_tweakData={
{#3D4, #00, #5F},{#3D4, #01, #3F},{#3D4, #02, #40},{#3D4, #03, #82},
{#3D4, #04, #4A},{#3D4, #05, #9A},{#3D4, #06, #0D},{#3D4, #07, #3E},
{#3D4, #08, #00},{#3D4, #09, #41},{#3D4, #10, #EA},{#3D4, #11, #AC},	
{#3D4, #12, #DF},{#3D4, #13, #20},{#3D4, #14, #40},{#3D4, #15, #E7},
{#3D4, #16, #06},{#3D4, #17, #A3},{#3C4, #01, #01},{#3C4, #04, #0E},
{#3CE, #05, #40},{#3CE, #06, #05},{#3C0, #30, #41}	
}


sequence window_title
atom last_message
sequence inregs,outregs,KeyBuffer,MouseBuffer
integer initfunc,mainfunc,exitfunc,lastkey,keystroke_

window_title = "Untitled"
last_message = 0
initfunc = 0
mainfunc = 0
exitfunc = 0
lastkey = 500
keystroke_ = 0



--############ Misc. stuff ############

global procedure WindowType(integer i1)
end procedure


global procedure WindowTitle(sequence s1)
end procedure




--############ VGA control stuff ############

procedure set_mode19()
 if sequence(dos_interrupt(#10,{0,0,0,0,0,0,#13,0,0,0})) then end if
end procedure


procedure open_CRTC()
integer b
 Output(#11,#3D4)
 b = Input(#3D5)
 b = and_bits(b,#7F)
 Output(#11,#3D4)
 Output(b,#3D5)
end procedure


procedure lock_CRTC()
integer b
 Output(#11,#3D4)
 b = Input(#3D5)
 b = or_bits(b,#80)
 Output(#11,#3D4)
 Output(b,#3D5)
end procedure


procedure set_vga_mode(integer w,integer h)
sequence outdata
  set_mode19()
  if w=256 then
    if h=MODE_Q then
      outdata = modeQ_tweakData 
    else
      outdata = modeNES_tweakData
    end if
    open_CRTC()
    for i=1 to 23 do
      WriteReg(outdata[i][1],outdata[i][2],outdata[i][3])
    end for
    lock_CRTC()
  end if
  VIDEO[1] = #A0000
end procedure



--############ Graphics ############

global function SetColorDepth(integer depth)
  if (depth!=8 and depth!=15 and depth!=16 and depth!=24) then
    return 1
  end if
  current_mode(eScreenW,eScreenH,depth)
  ConfigBMP(BMP_CONVERT,bitspp)
  if bitspp=8 then
    TextOutProc = textout8_id
    CharOutProc = charout8_id
  elsif (bitspp=15) or (bitspp=16) then
    TextOutProc = textout16_id
    CharOutProc = charout16_id
  elsif bitspp=24 then
    TextOutProc = textout24_id
    CharOutProc = charout24_id
  end if
  return 0
end function


--// Doesn't check for linear addressing. Beware!
global function GraphicsMode(object mode)
 if not sequence(mode) then
  if machine_func(5,-1) then end if
  gfxmode = 0
  return 0
 else
  if (mode[1]<VALID_MODES[1][1] or mode[1]>VALID_MODES[2][1]) then
   return 1
  end if
  if (mode[2]<VALID_MODES[1][2] or mode[1]>VALID_MODES[2][2]) then
   return 1
  end if
  if vesa_mode(mode[1],mode[2],bitspp) then
     if bitspp = 8 then
        if (mode[1] = 320 and mode[2] = 200) then
           set_vga_mode(320,200)
        elsif mode[1] = 256 then
           if (mode[2] = 256 or mode[2] = 240) then
              set_vga_mode(256,mode[2])
           else
              return 1
           end if
        else
           return 1
        end if
     else 
       return 1
     end if
  else
    VIDEO[1] = video_mem
  end if
  current_mode(mode[1],mode[2],bitspp2)
  ConfigBMP(BMP_CONVERT,bitspp)
  if bitspp=8 then
    TextOutProc = textout8_id
    CharOutProc = charout8_id
  elsif (bitspp=15) or (bitspp=16) then
    TextOutProc = textout16_id
    CharOutProc = charout16_id
  elsif bitspp=24 then
    TextOutProc = textout24_id
    CharOutProc = charout24_id
  end if
  return 0
 end if
end function



global procedure WaitRetrace()
  while (and_bits(Input(#03DA),8)!=0) do		
  end while
  while (and_bits(Input(#03DA),8)=0) do
  end while
end procedure



global procedure SetPalette(sequence pal)
  if gfxmode and CURRENT_MODE_DEPTH = 8 then
    for i=1 to 256 do
      Output(i-1,#3C8)
      Output(floor(pal[i][1]/4),#3C9)
      Output(floor(pal[i][2]/4),#3C9)
      Output(floor(pal[i][3]/4),#3C9)
    end for
  end if
end procedure


global procedure SetColor(integer c,sequence rgb)
  if gfxmode and CURRENT_MODE_DEPTH = 8 then
    Output(c,#3C8)
    Output(floor(rgb[1]),#3C9)
    Output(floor(rgb[2]),#3C9)
    Output(floor(rgb[3]),#3C9)
  end if
end procedure


global procedure SetByteScheme(integer r,integer g,integer b,integer a)
end procedure



global procedure Blit(sequence xy,sequence src,sequence dest,atom method)
  poke4(blit_x,xy[1])
  poke4(blit_y,xy[2])
  poke4(blit_src,src[1])
  poke4(blit_xdim,src[2])
  poke4(blit_ydim,src[3])
  poke4(blit_dest,dest[1])
  poke4(aMaxW,dest[2]-1)
  poke4(aMaxH,dest[3]-1)
  poke4(aPitch,dest[2]*bytespp)
  call(copymethodbpp[method])
end procedure



--############ Dummy functions included for compability ############

global function InitSoundSystem(integer freq,integer bts,integer stereo,integer chnls,integer cd,integer bass_flags)
 return 0
end function

global procedure SetMasterVolume(integer vol)
end procedure

global procedure SetVolume(atom ch,integer vol)
end procedure

global procedure SetPanning(atom ch,integer p)
end procedure

global procedure SetFrequency(atom ch,integer f)
end procedure


global function InitCD()
 return 0
end function

global function PlayCD(integer track,integer loopit,integer w)
  return 0 
end function

global procedure PauseCD()
end procedure

global procedure ResumeCD()

end procedure

global procedure StopCD()
end procedure

global function DiscPresent()
  return 1
end function


global function LoadWav(sequence fname,integer loop,integer flgs)
  return 1
end function

global function PlayWav(atom wavptr)
 return 1
end function

global function PlayWav3D(atom wavptr,sequence pos,sequence orient,sequence vel)
 return 1
end function

global procedure PauseWav(atom ch)
end procedure

global procedure ResumeWav(atom ch)
end procedure

global procedure StopWav(atom wavptr)
end procedure


global function LoadMod(sequence fname,integer flgs,integer loopit)
 return 1
end function

global function PlayMod(atom modptr)
 return 0
end function

global procedure StopMod(atom modptr)
end procedure

global function LoadMP3(sequence fname,integer flgs)
 return 1
end function

global function PlayMP3(atom mp3ptr,integer loopit)
 return 0
end function

global procedure StopMP3(atom mp3ptr)
end procedure

global procedure PauseAll()
end procedure

global procedure StopAll()
end procedure

global procedure CloseSoundSystem()
end procedure



--############ Input ############


--global function InstallInput()
  -- mouse_pointer(1)
-- return 0
--end function

--global procedure ReleaseInput()
--end procedure

global procedure UpdateInput()
  KeyBuffer = get_keys()
end procedure


global function KeyDown(integer keyCode)
  if length(KeyBuffer) then
    if find(keyCode,KeyBuffer) then
      return 1
    end if
  end if
  return 0
end function


global function GetKey()
integer k,l
  l = length(KeyBuffer)
  if l then
    for i=1 to l do
      k = KeyBuffer[i]
      if k != lastkey then
        lastkey = k
        return k
      end if
    end for
  else
    lastkey = 500
  end if
  return -1
end function


global function WaitKey()
integer k
  k = -1
  while k=-1 do
    UpdateInput()
    k = GetKey()
  end while
  return k
end function





global procedure Main(integer initf,integer mainf,integer exitf)
integer junk
 if mainf = -1 then
  return
 end if
 initfunc = initf
 mainfunc = mainf
 exitfunc = exitf
 junk = 0
 if initfunc != -1 then
  junk = call_func(initfunc,{ })
 end if
 if not junk then
   while 1 do
     if call_func(mainfunc,{ }) then
       exit
     end if
   end while			
   if exitfunc != -1 then
     if call_func(exitfunc,{ }) then end if
   end if
 end if
end procedure



global constant
KEY_ESCAPE	=	1,
KEY_1		=	2,
KEY_2		=	3,
KEY_3		=	4,
KEY_4		=	5,
KEY_5		=	6,
KEY_6		=	7,
KEY_7		=	8,
KEY_8		=	9,
KEY_9		=	10,
KEY_0		=	11,
KEY_MINUS	=	12,  -- /* - on main keyboard */
KEY_EQUALS	=	13,
KEY_BACK	=	14,  -- /* backspace */
KEY_TAB		=	15,
KEY_Q		=	16,
KEY_W		=	17,
KEY_E		=	18,
KEY_R		=	19,
KEY_T		=	20,
KEY_Y		=	21,
KEY_U		=	22,
KEY_I		=	23,
KEY_O		=	24,
KEY_P		=	25,
KEY_LBRACKET	=	26,
KEY_RBRACKET	=	27,
KEY_RETURN	=	28,   -- ENTER on main keyboard
KEY_LCONTROL	=	29,
KEY_A		=	30,
KEY_S		=	31,
KEY_D		=	32,
KEY_F		=	33,
KEY_G		=	34,
KEY_H		=	35,
KEY_J		=	36,
KEY_K		=	37,
KEY_L		=	38,
KEY_SEMICOLON	=	39,
KEY_APOSTROPHE	=	40,
KEY_GRAVE	=	41,  -- accent grave
KEY_LSHIFT	=	42,
KEY_BACKSLASH	=	43,
KEY_Z		=	44,
KEY_X		=	45,
KEY_C		=	46,
KEY_V		=	47,
KEY_B		=	48,
KEY_N		=	49,
KEY_M		=	50,
KEY_COMMA	=	51,
KEY_PERIOD	=	52,  -- . on main keyboard
KEY_SLASH	=	53,  -- / on main keyboard
KEY_RSHIFT	=	54,
KEY_MULTIPLY	=	55,  -- * on numeric keypad
KEY_LMENU	=	56,  -- left Alt
KEY_SPACE	=	57,
KEY_CAPITAL	=	58,
KEY_F1		=	59,
KEY_F2		=	60,
KEY_F3		=	61,
KEY_F4		=	62,
KEY_F5		=	63,
KEY_F6		=	64,
KEY_F7		=	65,
KEY_F8		=	66,
KEY_F9		=	67,
KEY_F10		=	68,
KEY_NUMLOCK	=	69,
KEY_SCROLL	=	70,
KEY_NUMPAD7	=	71,
KEY_NUMPAD8	=	72,
KEY_NUMPAD9	=	73,
KEY_SUBTRACT	=	74,
KEY_NUMPAD4	=	75,
KEY_NUMPAD5	=	76,
KEY_NUMPAD6	=	77,
KEY_ADD		=	78,
KEY_NUMPAD1	=	79,
KEY_NUMPAD2	=	80,
KEY_NUMPAD3	=	81,
KEY_NUMPAD0	=	82,
KEY_DECIMAL	=	83,
KEY_F11		=	87,
KEY_F12		=	88,

KEY_F13		=	#000000064,  -- (NEC PC98)
KEY_F14		=	#000000065,  -- (NEC PC98)
KEY_F15		=	#000000066,  -- (NEC PC98)

-- Japanese keyboard
KEY_KANA	=	#000000070,
KEY_CONVERT	=	#000000079,
KEY_NOCONVERT	=	#00000007B,
KEY_YEN		=	#00000007D,

KEY_NUMPADEQUALS =	#00000008D,   -- = on numkdb (NEC PC98)

KEY_CIRCUMFLEX	=	#000000090,
KEY_AT		=	#000000091,
KEY_COLON	=	#000000092,
KEY_UNDERLINE	=	#000000093,
KEY_KANJI	=	#000000094,
KEY_STOP	=	#000000095,
KEY_AX		=	#000000096,
KEY_UNLABELED	=	#000000097,
KEY_NUMPADENTER	=	284,
KEY_RCONTROL	=	285,
KEY_NUMPADCOMMA	=	#0000000B3,
KEY_DIVIDE	=	#0000000B5,
KEY_SYSRQ	=	#0000000B7,
KEY_RMENU	=	#0000000B8,
KEY_HOME	=	#0000000C7,
KEY_UP		=	328,
KEY_PRIOR	=	#0000000C9,
KEY_LEFT	=	331,
KEY_RIGHT	=	333,
KEY_END		=	335,
KEY_DOWN	=	336,
KEY_NEXT	=	#0000000D1,
KEY_INSERT	=	#0000000D2,
KEY_DELETE	=	#0000000D3,
KEY_LWIN	=	#0000000DB,
KEY_RWIN	=	#0000000DC,
KEY_APPS	=	#0000000DD,

--  Alternate names for some keys, to facilitate transition from DOS.
KEY_BACKSPACE	=	#00000000E,
KEY_NUMPADSTAR	=	#000000037,
KEY_LALT	=	#000000038,
KEY_CAPSLOCK	=	#00000003A,
KEY_NUMPADMINUS	=	#00000004A,
KEY_NUMPADPLUS	=	#00000004E,
KEY_NUMPADPERIOD =	#000000053,
KEY_NUMPADSLASH	=	309,
KEY_RALT	=	#0000000B8,
KEY_UPARROW	=	KEY_UP,
KEY_PGUP	=	329,
KEY_LEFTARROW	=	KEY_LEFT,
KEY_RIGHTARROW	=	KEY_RIGHT,
KEY_DOWNARROW	=	KEY_DOWN,
KEY_PGDN	=	#0000000D1
 