-- 000926

include file.e
include get.e
include wildcard.e
include validate.e
include jarodgen.def


global constant OPSYS = platform()
global constant VALID_MODES	= {{2,2},{1024,768}},             --// Allow any resolution from 2*2 to 1024*768.
		POINTER=1,WIDTH=2,HEIGHT=3,BITCOUNT=4,  --// Bitmap "structure" members.      
		ERRORCODE=5,PALETTE=6
--// Window types (only STANDARD is recognized).
global constant	BASIC = 0, STANDARD = 1, FULLSCREEN = 2


-- Device setup flags
global constant DEVICE_8BITS	= 1	-- use 8 bit resolution, else 16 bit
global constant DEVICE_MONO	= 2	-- use mono, else stereo
global constant DEVICE_3D		= 4	-- enable 3D functionality
global constant DEVICE_A3D		= 8	-- enable A3D functionality
global constant DEVICE_NOSYNC	= 16	-- disable synchronizers

-- Music flags
global constant MUSIC_RAMP		=1	-- normal ramping
global constant MUSIC_RAMPS	=2	-- sensitive ramping
-- Ramping doesn't take a lot of extra processing and improves
-- the sound quality by removing "clicks". Sensitive ramping will
-- leave sharp attacked samples, unlike normal ramping. 
global constant MUSIC_LOOP		=4	-- loop music
global constant MUSIC_FT2MOD	=16	-- play .MOD as FastTracker 2 does
global constant MUSIC_PT1MOD	=32	-- play .MOD as ProTracker 1 does
global constant MUSIC_MONO		=64	-- force mono mixing (less CPU usage)
global constant MUSIC_3D		=128	-- enable 3D functionality
global constant MUSIC_POSRESET	=256	-- stop all notes when moving position


global constant SAMPLE_8BITS	=1	-- 8 bit, else 16 bit
global constant SAMPLE_MONO	=2	-- mono, else stereo
global constant SAMPLE_LOOP	=4	-- looped
global constant SAMPLE_3D		=8	-- 3D functionality enabled
global constant SAMPLE_SOFTWARE	=16	-- it's NOT using hardware mixing
global constant SAMPLE_MUTEMAX	=32	-- muted at max distance (3D only)
global constant SAMPLE_VAM		=64	-- uses the DX7 voice allocation & management
global constant SAMPLE_OVER_VOL	=#10000	-- override lowest volume
global constant SAMPLE_OVER_POS	=#20000	-- override longest playing
global constant SAMPLE_OVER_DIST	=#30000 -- override furthest from listener (3D only)

global constant MP3_HALFRATE	=#10000 -- reduced quality MP3 (half sample rate)
global constant MP3_SETPOS		=#20000 -- enable seeking on the MP3

--// song info enumerators
global constant	TITLE = 1,
		ARTIST = 2,
		ALBUM = 3,
		YEAR = 4,
		COMMENTS = 5,
		GENRE = 6

--// fill-modes
global constant FM_HOLLOW = 1, FM_FILLED = 2


global integer bitspp,bitspp2,bytespp,gfxmode,
 	       eScreenW,eScreenH,eMaxW,eMaxH,ePitch,
               eStretchW,eStretchH,
	       BPP16IS15,
               CURRENT_MODE_WIDTH,CURRENT_MODE_HEIGHT,CURRENT_MODE_DEPTH,
	       TextOutProc,textout8_id,textout16_id,textout24_id,
	       CharOutProc,charout8_id,charout16_id,charout24_id,
               WINDOWED



global sequence copymethodbpp,VIDEO
sequence makecol_id
integer dither_,optimizePalette_
atom circleproc_,ellipseproc_,boxproc_


copymethodbpp = repeat(0,1023)
makecol_id = repeat(0,32)
VIDEO = {0,0,0}
BPP16IS15 = 0
WINDOWED = 0
eScreenW = 1
eScreenH = 1
gfxmode = 0

dither_ = 0
optimizePalette_ = 0




--############ misc. stuff ############

function replace_all(integer i1,sequence s1,integer i2)
integer l
sequence s2
  l = length(s1)
  if l then
    s2 = s1
    for i = 1 to l do
      if s1[i] = i1 then
        s2[i] = i2
      end if
    end for
    return s2
  end if
  return s1
end function


global function PATH(sequence p)
  if OPSYS = LINUX then
    return replace_all('\\', p, '/')
  else
    return replace_all('/', p, '\\')
  end if
end function


--// Poke a word (2 bytes) into memory
global procedure poke_2(atom dest,object word)
 if sequence(word) then
  for i=1 to length(word) do
   poke(dest+((i-1)*2),and_bits(word[i],#00FF))
   poke(dest+((i-1)*2)+1,floor(and_bits(word[i],#FF00)/256))
  end for
 else
  poke(dest,and_bits(word,#00FF))
  poke(dest+1,floor(and_bits(word,#FF00)/256))
 end if
end procedure

function peek3(atom src)
atom ret
 ret = peek(src)
 ret += peek(src+1)*#100
 ret += peek(src+2)*#10000
 return ret
end function


--// Convert a byte to a sequence of bits with the MSB first 
global function byte2bits(integer byte)
sequence retSeq
integer mask
 mask = 128
 retSeq = {0,0,0,0,0,0,0,0}
 for i = 1 to 8 do
  if and_bits(byte,mask)>0 then
   retSeq[i] = 1
  end if
 mask = floor(mask/2)
 end for
 return retSeq
end function


global function sequence_fill_filter(sequence def,sequence usr,sequence pre)
sequence s1
integer prePtr
 s1 = repeat(0,length(def))
 prePtr = 1
 for i=1 to length(def) do
  if atom(def[i]) then
   if def[i]=-1 then
    s1[i] = pre[prePtr]
    prePtr += 1
   else
    s1[i] = usr[i]
   end if
  else
   s1[i] = usr[i]
  end if
 end for
 return s1
end function


function get_extension(sequence s1)
integer l,c
  l = length(s1)
  c = 0
  while l do
    if s1[l]='.' then
      c = 1
      exit
    end if
    l -= 1
  end while
  if c then
    return s1[l+1..length(s1)]
  end if
  return {}
end function



global procedure shellsortdec(atom list1,atom list2,integer len)
 poke4(a_list1,list1)
 poke4(a_list2,list2)
 poke4(a_length,len)
 call(shell_sort_dec_)
end procedure

global function Find(integer a,atom b,integer c)
  poke4(a_tmp,a)
  poke4(a_list1,b)
  poke4(a_length,c)
  call(i32_find_)
  return peek4s(a_tmp)
end function


function lum_sort(sequence pal,sequence s1,integer i1)
integer l,r,g,b
sequence s2
atom l1,l2,c
  l = length(s1)
  l1 = allocate(l*4*2)
  l2 = l1 +(l*4)
  for i=1 to l do
    poke4(l1+((i-1)*4),i)
    c = 0
    for j=1 to i1 do
      r = pal[j][1]-s1[i][1]
      g = pal[j][2]-s1[i][2]
      b = pal[j][3]-s1[i][3]
      if r<0 then r = -r end if
      if g<0 then g = -g end if
      if b<0 then b = -b end if
      c += ((r*0.299)+(g*0.587)+(b*0.114))
    end for
    poke4(l2+(i-1),floor(c*8192))
  end for
  shellsortdec(l2,l1,l)
  s2 = peek4u({l1,l})
  free(l1)
  return s2
end function


function extract_rgb(integer a,integer b)
sequence rgb
  rgb = {0,0,0}
  if b=15 then
    rgb[3] = and_bits(a,31)*8
    rgb[2] = and_bits(floor(a/4),248)
    rgb[1] = and_bits(floor(a/128),248)
  elsif b=16 then
    rgb[3] = and_bits(a,31)*8
    rgb[2] = and_bits(floor(a/8),252)
    rgb[1] = and_bits(floor(a/256),248)
  elsif b=24 then
    rgb[3] = and_bits(a,255)
    rgb[2] = and_bits(floor(a/256),255)
    rgb[1] = and_bits(floor(a/65536),255)
  end if
  return rgb
end function


--// Search for a color (s1) in the palette (s2) based on the luminance differance.
function find_similar_lum(sequence s1,sequence s2,atom lum)
integer i1,i2,i3
  for i=1 to length(s2) do
    i1 = s2[i][1]-s1[1]
    if i1<0 then
      i1 = -i1 end if
    i2 = s2[i][2]-s1[2]
    if i2<0 then
      i2 = -i2
    end if
    i3 = s2[i][3]-s1[3]
    if i3<0 then
      i3 = -i3
    end if
    if ((i1*0.299)+(i2*0.587)+(i3*0.114))<lum then
      return i
    end if
end for
return 0
end function



--########## various music info loaders ##########

global function GetNSFInfo(sequence nsfFile)
integer fn,ch
integer version,songs,startsong,dataaddr,initaddr,playaddr,speed
sequence signature,name,artist,copyright
  fn = open(nsfFile,"rb")
  signature = {}
  name = {}
  artist = {}
  copyright = {}

  for i = 1 to 5 do
    signature = signature & getc(fn)
  end for

  version = getc(fn)
  songs = getc(fn)
  startsong = getc(fn)

  dataaddr = getc(fn) 
  dataaddr += (getc(fn)*256)

  initaddr = getc(fn) 
  initaddr += (getc(fn)*256)

  playaddr = getc(fn) 
  playaddr += (getc(fn)*256)

  for i=1 to 32 do
    ch = getc(fn)
    if ch then
      name = name & ch
    end if
  end for
  for i=1 to 32 do
    ch = getc(fn)
    if ch then
      artist = artist & ch
    end if
  end for
  for i=1 to 32 do
    ch = getc(fn)
    if ch then
     copyright = copyright & ch
    end if
  end for
  speed = getc(fn)
  speed += (getc(fn)*256)
  close(fn)
  return {name,artist,"<?>","<?>"," "&copyright,"<?>"}
end function



global function GetMODInfo(sequence modFile)
integer fn,ch
sequence name,artist,copyright
   fn = open(modFile,"rb")
   name = {}
   for i=1 to 20 do
     ch = getc(fn)
     if ch then
       name = name & ch
     end if
   end for
   close(fn)
   return {name,"<?>","<?>","<?>","<?>","<?>"}
end function



global function GetMP3Info(sequence mp3File)
  return repeat("<?>",6)
end function



global function GetS3MInfo(sequence s3mFile)
integer fn,ch,byte
sequence name,artist,copyright 
  fn = open(s3mFile,"rb")
  name = {}
  byte = 0
  ch = 1
  while ch do
    if byte=32 then 
      exit
    end if
    ch = getc(fn)
    if ch then
      name = name & ch
    end if
    byte += 1
  end while
  close(fn)
  return {name,"<?>","<?>","<?>","<?>","<?>"}
end function



global function GetSIDInfo(sequence sidFile)
integer fn,ch
sequence name,artist,copyright  
 fn = open(sidFile,"rb")
 if seek(fn,22) then end if
 name = {}
 artist = {}
 copyright = {}
 for i=1 to 32 do
  ch = getc(fn)
  if ch then
   name = name & ch
  end if
 end for
 for i=1 to 32 do
  ch = getc(fn)
  if ch then
   artist = artist & ch
  end if
 end for
 for i=1 to 32 do
  ch = getc(fn)
  if ch then
   copyright = copyright & ch
  end if
 end for
 close(fn)
 return {name,artist,"<?>","<?>"," "&copyright,"<?>"}
end function



global function GetSPCInfo(sequence spcFile)
integer fn,ch
sequence name,artist,copyright,spcversion
  name = {}
  artist = {}
  fn = open(spcFile,"rb")
  if seek(fn,29) then end if
  spcversion = {}
  for i=1 to 4 do
    spcversion = spcversion & getc(fn)
  end for
  spcversion = value(spcversion)
  if spcversion[1]!=GET_SUCCESS then
    close(fn)
    return repeat("<?>",6)
  end if
  if spcversion[2] = 0.20 then
    if seek(fn,48) then end if
    for i=1 to 32 do
      ch = getc(fn)
      if ch then
        name = name & ch
      end if
    end for
    close(fn)
    return {name,"<?>","<?>","<?>","<?>","<?>"}
  elsif spcversion[2] = 0.30 then
    if seek(fn,#23) then end if
    if getc(fn)=27 then
      close(fn)
      return repeat("<?>",6)
    end if
    if seek(fn,#4E) then end if
    for i=1 to 32 do
      ch = getc(fn)
      if ch then
        name = name & ch
      end if
    end for
    if seek(fn,#B0) then end if
    for i=1 to 32 do
      ch = getc(fn)
      if ch then
        artist = artist & ch
      end if
    end for
    close(fn)
    return {name,artist,"<?>","<?>","<?>","<?>"}
  else
    close(fn)
    return repeat("<?>",6)
  end if
end function



global function GetXMInfo(sequence xmFile)
integer fn,ch,byte
sequence name,artist,copyright 
  fn = open(xmFile,"rb")
  if seek(fn,17) then end if
  name = {}
  byte = 0
  ch = 1
  while ch!=26 do
    if byte=32 then 
      exit
    end if
    ch = getc(fn)
    if ch!=26 then
      name = name & ch
    end if
    byte += 1
  end while
  close(fn)
  return {name,"<?>","<?>","<?>","<?>","<?>"}
end function



global function GetSongInfo(sequence fname)
sequence s1
  s1 = upper(get_extension(fname))
  if not compare(s1,"MOD") then
    return GetMODInfo(fname)
  elsif not compare(s1,"MP3") then
    return GetMP3Info(fname)
  elsif not compare(s1,"NSF") then
    return GetNSFInfo(fname)
  elsif not compare(s1,"S3M") then
    return GetS3MInfo(fname)
  elsif not compare(s1,"SID") then
    return GetSIDInfo(fname)
  elsif not compare(s1,"SPC") then
    return GetSPCInfo(fname)
  elsif not compare(s1,"XM") then
    return GetXMInfo(fname)
  end if
  return repeat("<?>",6)
end function




--########## graphics stuff ##########

global procedure current_mode(integer xdim,integer ydim,integer bpp)
 bitspp2 = bpp
 if bpp=16 and BPP16IS15 then
   --// Ignore if we're in windowed mode.
   if not (OPSYS=WIN32 and WINDOWED) then
     bpp = 15
   end if
 end if
 if bpp = 8 then
   Pixel_ = pixel8_
   Box_ = box8_filled_
   poke4(line_pixelproc,Pixel_)
   poke4(hlineproc_,hline8_)
 elsif bpp<=16 then
   Pixel_ = pixel16_
   Box_ = box16_filled_
   poke4(line_pixelproc,Pixel_)
   poke4(hlineproc_,hline16_)
 else
   Pixel_ = pixel24_
   poke4(line_pixelproc,Pixel_)
   Box_ = box24_filled_
   poke4(hlineproc_,hline24_)
 end if
 eScreenW = xdim
 eScreenH = ydim
 VIDEO[2..3] = {xdim,ydim}
 eMaxW = xdim-1
 eMaxH = ydim-1
 bitspp = bpp
 bytespp = floor((bpp+1)/8)
 gfxmode = 1
 copymethodbpp = copymethod[bpp]
 poke4(aData,{eScreenW,eScreenH,eMaxW,eMaxH})
 poke4(fpuCopyIterations,-floor((eScreenW*eScreenH*bytespp)/8))
 poke4(bytesOnScreen,(eScreenW*eScreenH*bytespp))
 poke4(aPitch,(eScreenW*bytespp))
 poke4(aBytesPP,bytespp)
 CURRENT_MODE_WIDTH = xdim
 CURRENT_MODE_HEIGHT = ydim
 CURRENT_MODE_DEPTH = bpp
 ----if render_mode(xdim,ydim,bpp) then end if
end procedure



global procedure Pixel(sequence xy,integer col,sequence dest)
 poke4(aColor,col)
 poke4(blit_dest,dest[1])
 poke4(blit_x,xy)
 poke4(aMaxW,dest[2]-1)
 poke4(aMaxH,dest[3]-1)
 poke4(aPitch,dest[2]*bytespp)
 call(Pixel_)
end procedure


global procedure Box(sequence box,integer col,sequence dest)
 poke4(aColor,col)
 poke4(blit_dest,dest[1])
 poke4(blit_x1,box[1])
 poke4(blit_x2,box[2])
 poke4(aMaxW,dest[2]-1)
 poke4(aMaxH,dest[3]-1)
 poke4(aPitch,dest[2]*bytespp)
 call(boxproc_)
end procedure

global procedure Line(sequence coords,integer col,sequence dest)
 poke4(aColor,col)
 poke4(blit_dest,dest[1])
 poke4(blit_x1,coords[1])
 poke4(blit_x2,coords[2])
 poke4(aMaxW,dest[2]-1)
 poke4(aMaxH,dest[3]-1)
 poke4(aPitch,dest[2]*bytespp)
 call(line_)
end procedure


global procedure Circle(sequence centre,integer iRadius,integer col,sequence dest)
 poke4(aColor,col)
 poke4(circle_iRadius,iRadius)
 poke4(blit_dest,dest[1])
 poke4(blit_x,centre)
 poke4(aMaxW,dest[2]-1)
 poke4(aMaxH,dest[3]-1)
 poke4(aPitch,dest[2]*bytespp)
 call(circleproc_)
end procedure


global procedure SetFillMode(integer fm)
  if fm = FM_HOLLOW then
    circleproc_ = circle_
    boxproc_ = box_
  else
    circleproc_ = circle_filled_
    boxproc_ = Box_
  end if
end procedure


global function CreateBitmap(integer w,integer h,integer clear)
atom a
 a = allocate(w*h*bytespp)
 if a <= 0 then
  return {0,0,0,0,1,0}
 end if
 if clear then
  mem_set(a,0,w*h*bytespp)
 end if
 return {a,w,h,bitspp,0,0}
end function


global procedure DestroyBitmap(sequence s)
  if sequence(s[1]) then
    for i=1 to length(s) do
      free(s[i][1])
    end for
  else
    free(s[1])
  end if
end procedure


global procedure ClearBitmapIndex(sequence dest,integer col)
 poke4(blit_dest,dest[1])
 poke4(blit_xdim,dest[2])
 poke4(blit_ydim,dest[3])
 poke4(aColor,col)
 call(clearscreen[bitspp])
end procedure


global procedure SetMixtable(atom mt)
 if mt>0 then
  poke4(blit_mixtable,mt)
 end if
end procedure


global function Generate332Palette()
sequence p
 p = repeat({0,0,0},256)
 for c=0 to 255 do
  p[c+1][1] = and_bits(floor( and_bits(floor(c/32),7)*255/7),255 )
  p[c+1][2] = and_bits(floor( and_bits(floor(c/4),7)*255/7),255 )
  p[c+1][3] = and_bits(floor( and_bits(c,3)*255/3),255 )
 end for
 p[256] = {255,0,255}
 p[1] = {0,0,0}
 return p
end function


global procedure SetMatchPalette(sequence mpal)
 for i = 0 to 255 do
   poke4(match_pal+(i*12),mpal[i+1])
 end for
end procedure


function find_rgb(sequence rgb)
  poke4(match_data+match_REFR,rgb[1])
  poke4(match_data+match_REFG,rgb[2])
  poke4(match_data+match_REFB,rgb[3])
  poke4(match_data+match_MATCH,0)
  poke4(match_data+match_MINV,13107200)
  call(match_fast)
  return peek4s(match_data+match_MATCH)
end function


global function CreateMixtable(sequence pal1,sequence pal2,sequence pal_used)
atom mixtb
  mixtb = allocate(65536)
  if mixtb<=0 then
    return 0
  end if
  for i = 0 to 255 do
    poke4(match_pal+(i*12),pal_used[i+1])
  end for
  for i = 0 to 255 do
    for j = 0 to 255 do
      poke(mixtb+(i*256)+j,find_rgb(floor((pal1[i+1]+pal2[j+1])/2)))
    end for
  end for
  return mixtb
end function


global function MakeColor8(sequence rgb)
 return find_rgb(rgb)
end function
makecol_id[8] = routine_id("MakeColor8")

global function MakeColor15(sequence rgb)
integer col
 col = floor(rgb[3]/8)+and_bits(rgb[2]*4,#E0)
 col += ((floor(rgb[2]/64)+and_bits(rgb[1]/2,#7C))*256)
 return col
end function
makecol_id[15] = routine_id("MakeColor15")


global function MakeColor16(sequence rgb)
integer col
 col = floor(rgb[3]/8)+and_bits(rgb[2]*8,#E0)
 col += ((floor(rgb[2]/32)+and_bits(rgb[1],#F8))*256)
 return col
end function
makecol_id[16] = routine_id("MakeColor16")


global function MakeColor24(sequence rgb)
integer col
 col = rgb[3]+(rgb[2]*256)+(rgb[1]*65536)
 return col
end function
makecol_id[24] = routine_id("MakeColor24")

global function MakeColorDepth(integer depth,sequence rgb)
 return call_func(makecol_id[depth],{rgb})
end function

global function MakeColor(sequence rgb)
 return call_func(makecol_id[CURRENT_MODE_DEPTH],{rgb})
end function

global function MakeColorIndex(integer indx,sequence pal)
  if CURRENT_MODE_DEPTH=8 then
    return indx
  end if
  return call_func(makecol_id[CURRENT_MODE_DEPTH],{pal[indx+1]})
end function


global procedure ClearBitmapRGB(sequence dest,sequence rgb)
 poke4(blit_dest,dest[1])
 poke4(blit_xdim,dest[2])
 poke4(blit_ydim,dest[3])
 poke4(aColor,MakeColor(rgb))
 call(clearscreen[bitspp])
end procedure


global procedure SetMixColor(integer r,integer g,integer b,integer a)
 poke4(aColorR,{r,g,b,a})
end procedure

global procedure SetStretchSize(integer w,integer h)
 eStretchW = w
 eStretchH = h
 poke4(blit_stretch_w,w)
 poke4(blit_stretch_h,h)
end procedure



global function generate_paletteV(sequence img,integer colors)
integer a,b,c,x
integer entry,entries,bw
sequence s,crap,pal
atom a1,counts,ids,bw2
  if colors>256 then colors=256 end if
  colors -= 4
  pal = repeat({0,0,0},256)
  pal[2] = {220,0,0}
  pal[3] = {0,220,0}
  pal[4] = {0,0,220}
  entry = 5
  bw2 = img[2]/colors
  bw = floor(bw2)
  if bw=0 then
    bw = 1
  end if
  counts = allocate(bw*img[3]*4)
  ids = allocate(bw*img[3]*4)
  if counts<=0 or ids<=0 then
    return pal
  end if
  crap = repeat(0,colors)
  for i = 0 to colors-1 do
    x = floor(i*bw2)
    mem_set(counts,0,bw*img[3]*4)
    mem_set(ids,0,bw*img[3]*4)
    entries = 0
    for yy = 0 to img[3]-1 do
      for xx = 0 to bw-1 do
        if img[4]=15 or img[4]=16 then
          s = peek({img[1]+(yy*img[2]*2)+((x+xx)*2),2})
          a = s[1]+(s[2]*256)
        elsif img[4]=24 then
          a = peek3(img[1]+(yy*img[2]*3)+((x+xx)*3))
        end if
        b = Find(a,ids,entries) 
        if b!=-1 then
          poke4(counts+(b*4),peek4u(counts+(b*4))+1)
        else
          poke4(ids+(entries*4),a)
          poke4(counts+(entries*4),1)
          entries += 1
        end if
      end for
    end for
    shellsortdec(counts,ids,entries)
    a = 0
    while entries do
      --b = peek4u(ids+(a*4))
      --s = {floor(and_bits(b,#FF0000)/#10000),
      --     floor(and_bits(b,#FF00)/#100),and_bits(b,#FF)}
      s = extract_rgb(peek4u(ids+(a*4)),img[4])
      if find_similar_lum(s,pal,6.9) and (a+1)<entries then
        a += 1
      else
        pal[entry] = s
        entry += 1
        if entry>256 then
          free(counts)
          free(ids)
          return pal
        end if
        exit
      end if
    end while
    crap[i+1] = extract_rgb(peek4u(ids+4),img[4])
    --if call_func(progress,{i+1,colors}) then end if
   end for
  if entry<(colors+4) then
   c = 0
   for i=1 to (colors+4)-entry do
     pal[entry+(i-1)] = crap[c+1]
     c = remainder(c+8,colors)
   end for
  end if
  crap = {}
  free(counts)
  free(ids)
  return pal
end function


global procedure AllowDithering(integer i1)
  dither_ = i1
end procedure

global procedure AllowPaletteOptimization(integer i1)
  optimizePalette_ = i1
end procedure


global function GenerateOptimizedPalette(sequence s1)
  return generate_paletteV(s1,256)
end function


global function makeimage8(sequence imageX)
atom a
sequence p
  if optimizePalette_ then
    p = GenerateOptimizedPalette(imageX)
    SetMatchPalette(p)
  else
    p = repeat({0,0,0},256)
    for i = 0 to 255 do
      p[i+1][1] = peek(match_pal+(i*12))
      p[i+1][2] = peek(match_pal+(i*12)+4)
      p[i+1][3] = peek(match_pal+(i*12)+8)
    end for
  end if
  a = allocate(imageX[2]*imageX[3])
  if a<=0 then
    return 0
  end if
  poke4(a_src,imageX[POINTER])
  poke4(a_dest,a)
  poke4(a_xdim,imageX[WIDTH])
  poke4(a_ydim,imageX[HEIGHT])
  poke4(a_bits,imageX[BITCOUNT])
  if imageX[BITCOUNT] = 8 then
    for i = 0 to 255 do
      poke(match_pal2+(i*3),imageX[PALETTE][i+1])
    end for
  end if
  if dither_ then
    poke4(a_matchproc,dither_match_fast)
    call(dither_image)
  else
    poke4(a_matchproc,match_fast)
    call(convert_image)
  end if
  return {a,imageX[2],imageX[3],8,0,p}
end function




--################ Fonts ################

-- Load a .f font into memory 
global function LoadFont(sequence filename)
atom fn
integer maxw,maxh
integer firstChar,lastChar,numChars
integer junk
atom fontMem
sequence fontBits
 fn = open(filename,"rb")
 if fn=-1 then
  return 0
 end if
 firstChar = getc(fn)
 lastChar = getc(fn)
 maxw = getc(fn) 
 maxh = getc(fn)
 maxw *= 8
 numChars = (lastChar-firstChar)+1
 fontMem = allocate((numChars*maxw*maxh)+numChars+16)
 if fontMem<=0 then
  return {-1,-1,-1,-1,-1}
 end if
 junk = getc(fn)
 junk = getc(fn)
 poke4(fontMem,{firstChar,numChars,maxw,maxh})
 for i=1 to numChars do
  poke(fontMem+16+(i-1),getc(fn))
 end for
 for i = 1 to numChars do
  for j = 1 to maxh do
   for k = 1 to floor(maxw/8) do
    fontBits = byte2bits(getc(fn))
    poke(fontMem+numChars+16+((i-1)*maxh*maxw)+((j-1)*maxw)+((k-1)*8),fontBits)
   end for
  end for
 end for
 close(fn)
 return fontMem
end function



-- Remove a loaded font from memory
global procedure DestroyFont(atom loaded_font)
 if loaded_font>=0 then
  free(loaded_font)
 end if
end procedure




global procedure CharOut(sequence textCoords,integer text,atom textFont,integer textColor,sequence dest)
 call_proc(CharOutProc,{textCoords,text,textFont,textColor,dest})
end procedure


procedure CharOut8(sequence textCoords,integer text,atom textFont,integer textColor,sequence dest)
 poke4(textoutData,textCoords)
 poke4(textoutData+16,textColor)
 poke4(textoutData+24,dest[1])
 poke4(textoutData+60,textFont)
 poke4(textoutData+72,asm_char_code8_clip)
 poke(textoutStr,text&0)
 poke4(aMaxW,dest[2]-1)
 poke4(aMaxH,dest[3]-1)
 poke4(aPitch,dest[2])
 call(textout_code)
end procedure
charout8_id = routine_id("CharOut8")
CharOutProc = charout8_id


procedure CharOut16(sequence textCoords,integer text,atom textFont,integer textColor,sequence dest)
 poke4(textoutData,textCoords)
 poke4(textoutData+16,textColor)
 poke4(textoutData+24,dest[1])
 poke4(textoutData+60,textFont)
 poke4(textoutData+72,asm_char_code16_clip)
 poke(textoutStr,text&0)
 poke4(aMaxW,dest[2]-1)
 poke4(aMaxH,dest[3]-1)
 poke4(aPitch,dest[2]*2)
 call(textout_code)
end procedure
charout16_id = routine_id("CharOut16")


procedure CharOut24(sequence textCoords,integer text,atom textFont,integer textColor,sequence dest)
 poke4(textoutData,textCoords)
 poke4(textoutData+16,textColor)
 poke4(textoutData+24,dest[1])
 poke4(textoutData+60,textFont)
 poke4(textoutData+72,asm_char_code24_clip)
 poke(textoutStr,text&0)
 poke4(aMaxW,dest[2]-1)
 poke4(aMaxH,dest[3]-1)
 poke4(aPitch,dest[2]*3)
 call(textout_code)
end procedure
charout24_id = routine_id("CharOut24")


-- Print a text-string using given a font
global procedure TextOut(sequence textCoords,sequence text,atom textFont,integer textColor,sequence dest)
 call_proc(TextOutProc,{textCoords,text,textFont,textColor,dest})
end procedure


procedure TextOut8(sequence textCoords,sequence text,atom textFont,integer textColor,sequence dest)
 poke4(textoutData,textCoords)
 poke4(textoutData+16,textColor)
 poke4(textoutData+24,dest[1])
 poke4(textoutData+60,textFont)
 poke4(textoutData+72,asm_char_code8_clip)
 poke(textoutStr,text&0)
 poke4(aMaxW,dest[2]-1)
 poke4(aMaxH,dest[3]-1)
 poke4(aPitch,dest[2])
 call(textout_code)
end procedure
textout8_id = routine_id("TextOut8")
TextOutProc = textout8_id


procedure TextOut16(sequence textCoords,sequence text,atom textFont,integer textColor,sequence dest)
 poke4(textoutData,textCoords)
 poke4(textoutData+16,textColor)
 poke4(textoutData+24,dest[1])
 poke4(textoutData+60,textFont)
 poke4(textoutData+72,asm_char_code16_clip)
 poke(textoutStr,text&0)
 poke4(aMaxW,dest[2]-1)
 poke4(aMaxH,dest[3]-1)
 poke4(aPitch,dest[2]*2)
 call(textout_code)
end procedure
textout16_id = routine_id("TextOut16")


procedure TextOut24(sequence textCoords,sequence text,atom textFont,integer textColor,sequence dest)
 poke4(textoutData,textCoords)
 poke4(textoutData+16,textColor)
 poke4(textoutData+24,dest[1])
 poke4(textoutData+60,textFont)
 poke4(textoutData+72,asm_char_code24_clip)
 poke(textoutStr,text&0)
 poke4(aMaxW,dest[2]-1)
 poke4(aMaxH,dest[3]-1)
 poke4(aPitch,dest[2]*3)
 call(textout_code)
end procedure
textout24_id = routine_id("TextOut24")




global constant SYSTEM_PALETTE = 
{
{0,0,0},{0,0,42},{0,42,0},{0,42,42},{42,0,0},{42,0,42},{42,21,0},{42,42,42},{21,21,21},{21,21,63},{21,63,21},
{21,63,63},{63,21,21},{63,21,63},{63,63,21},{63,63,63},{0,0,0},{5,5,5},{8,8,8},{11,11,11},{14,14,14},{17,17,17},
{20,20,20},{24,24,24},{28,28,28},{32,32,32},{36,36,36},{40,40,40},{45,45,45},{50,50,50},{56,56,56},{63,63,63},{0,0,63},
{16,0,63},{31,0,63},{47,0,63},{63,0,63},{63,0,47},{63,0,31},{63,0,16},{63,0,0},{63,16,0},{63,31,0},{63,47,0},{63,63,0},
{47,63,0},{31,63,0},{16,63,0},{0,63,0},{0,63,16},{0,63,31},{0,63,47},{0,63,63},{0,47,63},{0,31,63},{0,16,63},{31,31,63},
{39,31,63},{47,31,63},{55,31,63},{63,31,63},{63,31,55},{63,31,47},{63,31,39},{63,31,31},{63,39,31},{63,47,31},
{63,55,31},{63,63,31},{55,63,31},{47,63,31},{39,63,31},{31,63,31},{31,63,39},{31,63,47},{31,63,55},{31,63,63},
{31,55,63},{31,47,63},{31,39,63},{45,45,63},{49,45,63},{54,45,63},{58,45,63},{63,45,63},{63,45,58},{63,45,54},
{63,45,49},{63,45,45},{63,49,45},{63,54,45},{63,58,45},{63,63,45},{58,63,45},{54,63,45},{49,63,45},{45,63,45},
{45,63,49},{45,63,54},{45,63,58},{45,63,63},{45,58,63},{45,54,63},{45,49,63},{0,0,28},{7,0,28},{14,0,28},{21,0,28},
{28,0,28},{28,0,21},{28,0,14},{28,0,7},{28,0,0},{28,7,0},{28,14,0},{28,21,0},{28,28,0},{21,28,0},{14,28,0},{7,28,0},
{0,28,0},{0,28,7},{0,28,14},{0,28,21},{0,28,28},{0,21,28},{0,14,28},{0,7,28},{14,14,28},{17,14,28},{21,14,28},{24,14,28},
{28,14,28},{28,14,24},{28,14,21},{28,14,17},{28,14,14},{28,17,14},{28,21,14},{28,24,14},{28,28,14},{24,28,14},{21,28,14},
{17,28,14},{14,28,14},{14,28,17},{14,28,21},{14,28,24},{14,28,28},{14,24,28},{14,21,28},{14,17,28},{20,20,28},{22,20,28},
{24,20,28},{26,20,28},{28,20,28},{28,20,26},{28,20,24},{28,20,22},{28,20,20},{28,22,20},{28,24,20},{28,26,20},{28,28,20},
{26,28,20},{24,28,20},{22,28,20},{20,28,20},{20,28,22},{20,28,24},{20,28,26},{20,28,28},{20,26,28},{20,24,28},{20,22,28},
{0,0,16},{4,0,16},{8,0,16},{12,0,16},{16,0,16},{16,0,12},{16,0,8},{16,0,4},{16,0,0},{16,4,0},{16,8,0},{16,12,0},{16,16,0},
{12,16,0},{8,16,0},{4,16,0},{0,16,0},{0,16,4},{0,16,8},{0,16,12},{0,16,16},{0,12,16},{0,8,16},{0,4,16},{8,8,16},{10,8,16},
{12,8,16},{14,8,16},{16,8,16},{16,8,14},{16,8,12},{16,8,10},{16,8,8},{16,10,8},{16,12,8},{16,14,8},{16,16,8},{14,16,8},
{12,16,8},{10,16,8},{8,16,8},{8,16,10},{8,16,12},{8,16,14},{8,16,16},{8,14,16},{8,12,16},{8,10,16},{11,11,16},{12,11,16},
{13,11,16},{15,11,16},{16,11,16},{16,11,15},{16,11,13},{16,11,12},{16,11,11},{16,12,11},{16,13,11},{16,15,11},{16,16,11},
{15,16,11},{13,16,11},{12,16,11},{11,16,11},{11,16,12},{11,16,13},{11,16,15},{11,16,16},{11,15,16},{11,13,16},{11,12,16},
{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0,0,0},{0,0,0}
}*4




load_jarodgen()

for i=2 to 1023 do
  if not copymethod[8][i] then
    copymethod[8][i] = copymethod[8][SOURCECOPY]
  end if
  if not copymethod[15][i] then
    copymethod[15][i] = copymethod[15][SOURCECOPY]
  end if
  if not copymethod[16][i] then
    copymethod[16][i] = copymethod[16][SOURCECOPY]
  end if
  if not copymethod[24][i] then
    copymethod[24][i] = copymethod[24][SOURCECOPY]
  end if
end for

current_mode(eScreenW,eScreenH,8)
SetFillMode(FM_HOLLOW)
SetMatchPalette(SYSTEM_PALETTE)


