-- Demonstration program for Jarod a/k/a/ the Pretender
-- /Mic, 2000
-- http://www.cyd.liu.se/~micol972/site/jarod.htm
--
-- This program demonstates the usage of drawing-primitives (pixels, lines etc.)
--
-- Works in 8, 15, 16 & 24-bit modes.
--

include jarod.e



constant BPP = 8



sequence vscreen
integer part
atom fnt
integer textcolor,limit



function init()
  if SetColorDepth(BPP) then end if
  --// Set mode 320*200*256.
  if GraphicsMode({320,200}) then
    --// Failed -> abort program.
    return 1
  end if
  SetPalette(SYSTEM_PALETTE)

  if BPP=8 then
    textcolor = 15
    limit = 256
  elsif BPP=15 then
    textcolor = #7FFF
    limit = #8000
  elsif BPP=16 then
    textcolor = #FFFF
    limit = #10000
  else
    textcolor = #FFFFFF
    limit = #1000000
  end if

  --// Create an offscreen buffer.
  vscreen = CreateBitmap(320,200,1)
  if vscreen[ERRORCODE] then
    return 1
  end if

  fnt = LoadFont(PATH("fonts/font.f"))

  part = 1

  return 0
end function



function display()
  --// Update input data.
  UpdateInput()
  if GetKey() != -1 then
    ClearBitmapIndex(vscreen,0)
    part += 1
    if part = 4 or part=6 then
      SetFillMode(FM_FILLED)
    elsif part = 5 then
      SetFillMode(FM_HOLLOW)
    elsif part = 7 then
      return 1
    end if
  end if


 --/* Useful info:
 --    The order of the co-ordinates you send to Line() and Box() doesn't matter.
 --    The co-ordinates you send to Circle() is the *center* of the circle.
 --    The 2nd parameter of Circle() (the radius) must be an integer. */


  if part=1 then
    --/* Draw more than one object per frame, or it'd look too slow :)
    --
    --   (We can't draw directly to VIDEO so we'll have to do it
    --   like this..) */
    for i = 1 to 50 do
      Pixel(rand({320,200}),rand(limit)-1,vscreen)
    end for

  elsif part=2 then
    for i = 1 to 4 do
      Line({rand({320,200}),rand({320,200})},rand(limit)-1,vscreen)
    end for

  elsif part=3 then
    for i = 1 to 3 do
      Circle(rand({320,200}),rand(40),rand(limit)-1,vscreen)
    end for

  elsif part=4 then
      Circle(rand({320,200}),rand(40),rand(limit)-1,vscreen)

  elsif part=5 or part=6 then
      Box({rand({320,200}),rand({320,200})},rand(limit)-1,vscreen)

  end if
  TextOut({108,2},"Press a key..",fnt,textcolor,vscreen)

  WaitRetrace()
  --// SCREENCOPY <=> SOURCECOPY+NOCLIPCOPY
  Blit({0,0},vscreen,VIDEO,SCREENCOPY)

  return 0
end function



function quit()
  DestroyBitmap(vscreen)
  DestroyFont(fnt)
  if GraphicsMode(0) then
  end if
  return 0
end function



WindowType(STANDARD)
WindowTitle("Jarod|jTest01")
Main(routine_id("init"),routine_id("display"),routine_id("quit"))
