-- Demonstration program for Jarod a/k/a/ the Pretender
-- /Mic, 2000
--
-- This program demonstrates the usage of alpha- & rbg-blending.
--
-- Works in 8, 15, & 16-bit modes.
--

include jarod.e




--// Change this if you like. Possible values: 8, 15, 16.
constant BPP = 16


sequence img1,img2,img3,vscreen
sequence pos1,pos2
atom an1,d_an1,f

integer frames,fcol
atom thistime,lasttime, mixtb
sequence fps

integer alpha1,d_alpha1,
        alpha2,d_alpha2,d 
alpha1 = 10
d_alpha1 = 1
alpha2 = 130
d_alpha2 = -1
pos1 = {0,0}
pos2 = {0,5}
an1 = 0.0
d_an1 = 3.141592654/180.0
d = 1



function init()
sequence temp

  if OPSYS=WIN32 then
    BPP16IS15 = 1
  end if
  if SetColorDepth(BPP) then
    return 1
  end if

  if GraphicsMode({640,480}) then
    return 1
  end if

  if BPP = 8 then
    AllowDithering(1)
    temp = Generate332Palette()
    mixtb = CreateMixtable(temp,temp,temp)
    SetMixtable(mixtb)
    --// Set the palette used by the ??-bpp to 8-bpp converter.
    SetMatchPalette(temp)
  end if

  f = LoadFont(PATH("fonts/brid8x16.f"))
  img1 = LoadBitmap(PATH("images/mario5.bmp"))
  img2 = LoadBitmap(PATH("images/chibimarukochan.bmp"))
  img3 = LoadBitmap(PATH("images/brickx2.bmp"))
  vscreen = CreateBitmap(640,480,1)
  if img1[ERRORCODE] or
     img2[ERRORCODE] or
     img3[ERRORCODE] or
     vscreen[ERRORCODE] then
    return 1
  end if
  if BPP=8 then SetPalette(temp) end if
  fcol = MakeColor({100,250,105})

  frames = 0
  fps = "?? fps"
  lasttime = time()
  return 0
end function



function display()
integer key
  UpdateInput()
  key = GetKey()
  if key = KEY_ESCAPE then
    return 1
  end if

  pos1 = floor({(95 * cos(an1)) + 160, (95 * sin(an1)) + 100})
  pos2[1] = floor(100 * cos(pos2[2] * 3 * d_an1)) + 188

  --// Draw background (brickx2.bmp)
  Blit({64,-16},img3,vscreen,SOURCECOPY)
  Blit({320,-16},img3,vscreen,SOURCECOPY)
  Blit({64,240},img3,vscreen,SOURCECOPY)
  Blit({320,240},img3,vscreen,SOURCECOPY)

  --// Draw lit sprite.
  SetMixColor(alpha2,floor(alpha2/2),50,0)
  Blit(pos2,img2,vscreen,LITCOPY)

  --// Draw transparent sprite.
  SetMixColor(40,110,190,alpha1)
  Blit(pos1,img1,vscreen,TRANSCOPY)
 
  --// Print fps.
  TextOut({80,16},fps,f,fcol,vscreen)

  --// Copy to video.
  WaitRetrace()
  Blit({0,0},vscreen,VIDEO,SOURCECOPY+NOCLIPCOPY)

  alpha1 += d_alpha1
  if alpha1=254 or alpha1=1 then
    d_alpha1 = -d_alpha1
  end if
  alpha2 += d_alpha2
  if alpha2=254 or alpha2=1 then
    d_alpha2 = -d_alpha2
  end if
  an1 += d_an1
  pos2[2] += d
  if pos2[2]>380 or pos2[2]<-41 then
    d = -d
  end if

  --// Recalculate the fps-rate every 100:d frame
  frames += 1
  if frames=100 then
    thistime = time()
    --// Avoid a division-by-zero, even though it's unlikely to happend
    if thistime=lasttime then thistime += 0.01 end if
    fps = sprintf("%02d fps",floor(100/(thistime-lasttime)))
    lasttime = thistime
    frames = 0
  end if

  return 0
end function



function quit()
  if BPP=8 then
    free(mixtb)
  end if
  DestroyBitmap({img1,img2,img3,vscreen})
  DestroyFont(f)
  if GraphicsMode(0) then end if
  return 0
end function


--WindowType(STANDARD)
WindowTitle("Jarod|jTest08")
Main(routine_id("init"),routine_id("display"),routine_id("quit"))
