-- Demonstration program for Jarod a/k/a/ the Pretender.
-- /Mic, 2000
--
-- Simple raycaster complete with fish-eye :) 
-- This is basically a rip-off from a program previously released by ??? (could be
-- Hollow Horse Software). I've added a few things:
--  * Better looking sky
--  * Better looking ground (erm.. well, it's not just *one* color anyway..)
--  * Ugly shading
--
-- Exclusively for 256-color modes!
--

  
include jarod.e


sequence ct, st
sequence world
sequence pal
atom f

st = repeat(0,361)
ct = st

procedure makeWorld()
world=repeat(0,20)
 world[1]= "191919191991991199119919199199"
 world[2]= "900000000070007000011050000001"
 world[3]= "100000000070007104110500005009"
 world[4]= "900100500057077000110500003001"
 world[5]= "100004000070507011050000030009"
 world[6]= "903000000040707011050000002041"
 world[7]= "100007800040002001105000000009"
 world[8]= "905008700070007001105000066001"
 world[9]= "100000000000000011050000040009"
 world[10]="108888800001105000000000070009"
 world[11]="108800080005500110500000070009"
 world[12]="108000080005500011050000000009"
 world[13]="108000080005500110500000433009"
 world[14]="108070000000001105000000000509"
 world[15]="108000000000440001105000000509"
 world[16]="108000560011050000000000230509"
 world[17]="100000200000003200110500000609"
 world[18]="100033300000000441105000886009"
 world[19]="100000000001105000000008800009"
 world[20]="919191991191191991919191919111"
 world -= '0'
end procedure


procedure makeTables()
atom t1, t2
  t1 = 3.14159265/180
  t2 = 0
  for A = 1 to 361 do
    t2 += t1
    ct[A] = cos(t2)
    st[A] = sin(t2)
  end for
  ct *= 2
  st *= 2
end procedure


atom xb, yb
atom Bx, By, dd
atom Px, Py, sa, temp, oldPx, oldPy
integer T
integer x, xTemp
integer l, k
integer xpos,ypos
sequence ut
sequence vscreen, vscreen2
integer blitter



 
function init()
 if WINDOWED and OPSYS=WIN32 then
   if GraphicsMode({320,200}) then
     --// Return 1 if GraphicsMode() failed (abort program).
     return 1
   end if
 else
   --// Set a 640*480*256 mode.
   if GraphicsMode({640,480}) then
     return 1
   end if
 end if


 blitter = SCREENCOPY
 xpos = floor((CURRENT_MODE_WIDTH-320)/2)
 ypos = floor((CURRENT_MODE_HEIGHT-200)/2)


 --// Create two offscreen buffers. Clear both on creation (third parameter).
 vscreen = CreateBitmap(320,200,1)
 vscreen2 = CreateBitmap(320,200,1)

 makeWorld()
 makeTables()

 --// PATH() replaces all /'s with \'s under DOS/WIN. Does the opposite under Linux.
 f = LoadFont(PATH("fonts/font.f"))

 --// Place player at map coords {30,20}. Set angle to 0.
 Px = 30
 Py = 20
 sa = 0

 --// Calculate palette.
 pal = repeat({0,0,0},256)
 for i = 1 to 16 do
   pal[i+1] = {(i*3),0,0}+8
   pal[i+17] = {0,(i*3),0}+8
   pal[i+33] = {0,0,(i*3)}+8
   pal[i+49] = {(i*3),(i*3),0}+8
   pal[i+65] = {(i*3),0,(i*3)}+8
   pal[i+81] = {0,(i*3),(i*3)}+8
   pal[i+97] = {0,(i*3),(i*3)}+8
   pal[i+113] = {i,(i*3),(i*2)}+8
   pal[i+129] = {(i*3),i,i}+8
 end for
 for i = 0 to 21 do
   pal[146+i] = {28-i,42-(2*i),61}
   pal[168+i] = {0,0,floor(61-(i*1.8))}
   pal[190+i] = {27+i,12+i,6+i}
 end for
 SetPalette(pal*4)
 vscreen[PALETTE] = pal*4


 --// <Draw sky & ground>
 for i = 0 to 63999 do
   poke(vscreen2[POINTER]+i,rand(9)+63+126)
 end for

 mem_set(vscreen2[POINTER],62+126,(10*320))
 mem_set(vscreen2[POINTER]+(10*320),61+126,(6*320))
 mem_set(vscreen2[POINTER]+(16*320),60+126,(4*320))
 for i = 20 to 99 do
   mem_set(vscreen2[POINTER]+(i*320),126+59-floor((i-20)/1.9),320)
 end for
 mem_set(vscreen2[POINTER],0,10)

 temp = 310
 for A = 1 to 199 do
   mem_set(vscreen2[POINTER]+temp,0,20)
   temp += 320
 end for
 mem_set(vscreen2[POINTER]+temp,0,10)
 --// </Draw sky & ground>

 return 0
end function




function display()
integer pix
 --// Copy vscreen2 (sky & ground) to vscreen.
 Blit({0,0},vscreen2,vscreen,SOURCECOPY+NOCLIPCOPY)

 --// 60 degrees FOV.
 T = sa+59
 for t = sa to T do
   xTemp = floor(remainder(t,360))+1
   xb = st[xTemp]/2
   yb = ct[xTemp]/2
   Bx = Px
   By = Py
   l = 0
   k = 0
   while k=0 do
     Bx += xb
     By += yb
     l += 1
     k = world[floor(By/10)][floor(Bx/10)]
   end while
   x = (t-sa)*5+10
   dd = floor(1000/l)
   if dd>99 then dd = 99 end if
   if dd<-99 then dd = -99 end if
   pix = floor(l*15/100)
   if pix>15 then pix = 15 end if
   ut = repeat((k*16)-pix,5)
   --// Draw one vertical section.
   for u = 99-dd to 100+dd do
     poke(vscreen[POINTER]+(floor(u)*320)+floor(x),ut)
   end for
 end for

 TextOut({36,8},"Press 'S' to save a snapshot",f,146,vscreen)
 WaitRetrace()
 Blit({xpos,ypos},vscreen,VIDEO,blitter)

 
 UpdateInput()
 --// Process keystrokes.
 if GetKey()=KEY_S then
   if SaveBitmap("ray.bmp",vscreen,vscreen) then end if
 end if
 if KeyDown(KEY_RIGHT) then	--right
   sa += 4
 end if
 if KeyDown(KEY_LEFT) then	--left
   sa = remainder((sa+356),360)
 end if
 if KeyDown(KEY_ESCAPE) then	--quit
   return 1
 end if
 T = floor((T+sa)/2)
 xTemp = remainder(T,360)+1
 if KeyDown(KEY_UP) then	--up
   oldPx = Px
   oldPy = Py
   Px += st[xTemp]
   Py += ct[xTemp]
   if world[floor(Py/10)][floor(Px/10)]>0 then
     Px = oldPx
     Py = oldPy
   end if
 end if
 if KeyDown(KEY_DOWN) then	--down
   oldPx = Px
   oldPy = Py
   Px -= st[xTemp]
   Py -= ct[xTemp]
   if world[floor(Py/10)][floor(Px/10)]>0 then
     Px = oldPx
     Py = oldPy
   end if
 end if

 return 0
end function



function theend()
 if GraphicsMode(0) then
 end if
 --// Remove the font from memory and destroy the virtual screens.
 DestroyFont(f)
 DestroyBitmap({vscreen,vscreen2})
 return 0
end function


--// Run in windowed mode (=fullscreen under DOS).
--WindowType(STANDARD)
Main(routine_id("init"),routine_id("display"),routine_id("theend"))


 

