without warning

include jarod.e
include asm.e


constant asm_i=allocate(4), asm_j=allocate(4), rotoscreen=allocate(4)
constant rzoom_data=allocate(20)

constant rotostruct={0,0,0,0},		-- emulate "typedef"
         ROT=1,DR=2,DIST=3,DD=4

sequence cosTb,sinTb, cosTb2,sinTb2
sequence vscreen,vscreen2, img, pal
sequence r
integer rotX        
atom mixx
atom rZoomCode,var_i,var_j
atom tm1,tm2,frames,rotY

--There'll be 256 angles
cosTb = repeat(0,256)
sinTb = cosTb
cosTb2 = cosTb
sinTb2 = cosTb


-- Rounds an atom to the nearest integer
function round(atom crap)
integer iCrap
 iCrap=floor(crap)
 if ((crap-iCrap)>0.5) then
  return (iCrap+1)
 else
  return iCrap
 end if
end function


-- Make trigonometric tables for later use
procedure makeTables()
atom angle
atom vfix, vfix2
 vfix=(3.14159265/128)
 vfix2=(3.14159265/2)
 for i=1 to 256 do
  angle=(i-1)
  angle=(angle*vfix)
  sinTb[i]=floor(sin(angle)*256)
  cosTb[i]=floor(cos(angle)*256)
  -- Multiply by 1.2 to adjust for the non-square pixel ratio
  sinTb2[i]=floor(sin(angle+vfix2)*256*1.2)
  cosTb2[i]=floor(cos(angle+vfix2)*256*1.2)
 end for
end procedure


function tile_texture(sequence tex)
integer dst
atom Tiled
 Tiled = allocate(256*256)
 if Tiled<=0 then
  return -1
 end if
 for v = 0 to 255 do
  for u = 0 to 255 do
   dst = and_bits((u*256),#F800)+and_bits(u,7)+and_bits((v*8),#07F8)
   poke(Tiled+dst,peek(tex[1]+(v*256)+u))
  end for
 end for
 DestroyBitmap(tex)
 return Tiled & tex[WIDTH..PALETTE]
end function





function init()
 if GraphicsMode({320,240}) then
  return 1
 end if
 img = LoadBitmap(PATH("images/sdasuka3.bmp"))
 vscreen = CreateBitmap(320,200,1)
 vscreen2 = CreateBitmap(320,200,1)
 pal = img[PALETTE]
 pal[1] = {0,0,0}	-- without this the screen border will be white, cos of the picture's palette	
 mixx = CreateMixtable(pal,pal,pal)
 SetMixtable(mixx)
 SetPalette(pal)
 img = tile_texture(img)
 vscreen[PALETTE] = pal
 if (vscreen[1]<=0) or (vscreen2[1]<=0) or (mixx<=0) then
  return 1
 end if

rZoomCode = get_asm(
"pusha cld "&
"mov eax,[tildudx] "&
"mov ebp,eax "&
"mov edx,eax "&
"shl eax,8 "&
"and eax,4160749568 "&
"shr ebp,1 "&
"and ebp,32767 "&
"and edx,458752 "&
"add eax,ebp "&
"add eax,edx "&
"or eax,133726208 "&
"mov [tildudx],eax "&
"mov eax,[tildvdx] "&
"mov ebp,eax "&
"shl eax,3 "&
"and eax,133693440 "&
"shr ebp,1 "&
"and ebp,32767 "&
"add eax,ebp "&
"or eax,4161241088 "&
"mov [tildvdx],eax "&
"xor ebx,ebx "&
"mov eax,var_i "&
"mov [asm_i],eax "&
"mov eax,var_j "&
"mov [asm_j],eax "&
"mov esi,spriteAddr "&
"mov edi,[screenAddr] "&
"mov ecx,200 "&
"vLoop: "&
"push ecx "&
"push edi "&
"mov ebp,[asm_i] "&
"mov eax,ebp "&
"mov ecx,ebp "&
"shl ebp,8 "&
"shr eax,1 "&
"and ebp,4160749568 "&
"and eax,32767 "&
"and ecx,458752 "&
"add ebp,eax "&
"add ebp,ecx "&
"mov edx,[asm_j] "&
"mov eax,edx "&
"shl edx,3 "&
"shr eax,1 "&
"and edx,133693440 "&
"and eax,32767 "&
"mov ebx,eax "&
"add ebx,edx "&
"mov ecx,320 "&
"add edi,319 "&
"xor ecx,-1 "&
"add ecx,2 "&		-- only draw 319 pixels per scanline, or the program will cause a GPF (ack..)
"lea eax,[ebx + ebp] "&
"inner: "&
"add ebp,[tildudx] "&
"add ebx,[tildvdx] "&
"shr eax,16 "&
"and ebp,4161241087 "&	-- 11111000 00000111 01111111 11111111
"and ebx,133726207 "&	-- 00000111 11111000 01111111 11111111
"mov dl,[esi + eax] "&
"mov [edi + ecx],dl "&
"lea eax,[ebp + ebx] "&
"inc ecx "&
"jnz inner "&
"mov eax,[asm_i] "&
"add eax,[tildudx_2] "&
"mov [asm_i],eax "&
"mov eax,[asm_j] "&
"add eax,[tildvdx_2] "&
"mov [asm_j],eax "&
"pop edi add edi,320 "&
"pop ecx "&
"dec ecx "&
"jz rz_@done "&
"mov eax,rz_label_vloop "&
"jmp near eax "&
"rz_@done: "&
"popa ret")
resolve_param("spriteAddr",img[1])
resolve_param("screenAddr",rotoscreen)
resolve_param("tildudx",rzoom_data)
resolve_param("tildvdx",rzoom_data+4)
resolve_param("tildudx_2",rzoom_data+8)
resolve_param("tildvdx_2",rzoom_data+12)
resolve_param("rz_label_vloop",rZoomCode+get_label("vLoop"))
resolve_param("asm_i",asm_i)
resolve_param("asm_j",asm_j)
var_i = rZoomCode + get_param("var_i")
var_j = rZoomCode + get_param("var_j")

 makeTables()
 rotX = 32768
 rotY = 0
 r = repeat(rotostruct,2)
 r[1] = {1,1,1000,65526}
 r[2] = {33,-2,205,65527}
 return 0
end function


-- Do some precalculations and then call the assembly code
procedure drawScreen(atom dest,integer x,atom y,integer scale,integer rot)
integer temp
integer ddx,ddy,d2x,d2y
integer i,j
 temp=(cosTb[rot])
 temp=floor((temp*scale)/256)
 ddx=temp
 temp=(sinTb[rot])
 temp=floor((temp*scale)/256)
 ddy=temp
 temp=(cosTb2[rot])
 temp=floor((temp*scale)/256)
 d2x=temp
 temp=(sinTb2[rot])
 temp=floor((temp*scale)/256)
 d2y=temp
 i=x-(ddx*160)-(d2x*100)
 j=y-(ddy*160)-(d2y*100)
 poke4(var_i,i*256)				
 poke4(var_j,j*256)				
 poke4(rzoom_data,{ddx,ddy,d2x,d2y}*256)	
 poke4(rotoscreen,dest)
 call(rZoomCode)
end procedure




function display()
 UpdateInput()
 if GetKey() = KEY_ESCAPE then
  return 1
 end if

 drawScreen(vscreen[POINTER],rotX,rotY,r[1][DIST],r[1][ROT]+1) 	-- Draw the stuff to the buffer (vscreen)
 drawScreen(vscreen2[POINTER],rotX,rotY,r[2][DIST],r[2][ROT]+1)
 if r[1][DIST]<r[2][DIST] then
   Blit({0,0},vscreen,vscreen2,MIXCOPY+NOCLIPCOPY)
   WaitRetrace()			 	
   Blit({0,19},vscreen2,VIDEO,SOURCECOPY+NOCLIPCOPY)
 else
   Blit({0,0},vscreen2,vscreen,MIXCOPY+NOCLIPCOPY)
   WaitRetrace()			 	
   Blit({0,19},vscreen,VIDEO,SOURCECOPY+NOCLIPCOPY)
 end if

 rotY += 128
 for n = 1 to 2 do			-- putting this in a loop makes it easier to add more layers
   r[n][ROT] += r[n][DR]
   r[n][DIST] = and_bits(r[n][DIST]+r[n][DD],#0FFFF)
   if (r[n][DIST]>=1800) or (r[n][DIST]<=20) then
     r[n][DD] = -r[n][DD]
   end if
   if (rand(150)=1) then
     r[n][DR] = rand(7)-3
   end if
   r[n][ROT] = and_bits(r[n][ROT],#0FF)
 end for 
 return 0
end function



function quit()
 if GraphicsMode(0) then end if
 DestroyBitmap({vscreen,vscreen2,img})
 free(mixx)
 free(rZoomCode)
 free(asm_i)
 free(asm_j)
 return 0
end function


WindowType(STANDARD)
Main(routine_id("init"),routine_id("display"),routine_id("quit"))

